-- Filename:     nand2.vhd
-- Filetype:     VHDL code
-- Date:         3 feb 2013
-- Update:       -
-- Description:  A logical description of a two-input NAND port
-- Author:       J. op den Brouw
-- State:        demo
-- Error:        -
-- Version:      1.0
-- Copyright:    (c)2013, De Haagse Hogeschool
--
-- This is an example of a logical (dataflow) description
-- of a two-input NAND port.

library ieee;
use ieee.std_LOGIC_1164.all;

-- The input and ouput signals
entity Nand_2 is
    port (
        P: in std_logic;
        Q: in std_logic;
        R: out std_logic
    );
end Nand_2;

-- Logical description of the NAND port
architecture logical of Nand_2 is
begin
	R <= not (P and Q);
end logical;
