# Filename:     tb_xor4nands.do
# Filetype:     Modelsim Script File
# Date:         3 maart 2013
# Update:       -
# Description:  Script file voor automatische simulatie
# Author:       J. op den Brouw
# State:        demo
# Error:        -
# Version:      1.1
# Copyright:    (c)2011, De Haagse Hogeschool

# Transcript on
transcript on

# Create working directory
if {[file exists rtl_work]} {
	vdel -lib rtl_work -all
}
vlib rtl_work
vmap work rtl_work

# Find out if we're started through Quartus or by hand
# (or by using an exec in the Tcl window in Quartus).
# Quartus has the annoying property that it will start
# Modelsim from a directory called "simulation/modelsim".
# The design and the testbench are located in the project
# root, so we've to compensate for that.
if [ string match "*simulation/modelsim" [pwd] ] { 
	set prefix "../../"
	puts "Running Modelsim from Quartus..."
} else {
	set prefix ""
	puts "Running Modelsim..."
}

# Compile the VHDL descriptions and testbench,
# please note that the design and its testbench is located
# in the project root, but the simulator start in directory
# <project_root>/simulation/modelsim, so we have to compensate
# for that.
vcom -2008 -work work ${prefix}nand2.vhd
vcom -2008 -work work ${prefix}xor4nands.vhd
vcom -2008 -work work ${prefix}tb_xor4nands.vhd

# Start the simulator with 1 ns resolution
vsim -t 1ns -L rtl_work -L work -voptargs="+acc" tb_xor4nands

# Log all signals in the design, good if the number
# of signals is small.
add log -r *

# Add all toplevel signals
# Add a number of signals of the simulated design
add list *
add list dut/a
add list dut/b
add list dut/c

# Add all toplevel signals
# Add a number of signals of the simulated design
add wave -divider "Inputs"
add wave x
add wave y
add wave -divider "Internals"
add wave dut/a
add wave dut/b
add wave dut/c
add wave -divider "Output"
add wave s

# Open Structure, Signals (waveform) and List window
view structure
view list
view wave

# Run simulation for 800 ns
run 800 ns

# Fill up the waveform in the window
wave zoom full
