-- Filename:     tb_xor4nands.vhd
-- Filetype:     VHDL testbench
-- Date:         16 maart 2011
-- Update:       -
-- Description:  VHDL testbench code voor xor4nands.vhd
-- Author:       J. op den Brouw
-- State:        demo
-- Error:        -
-- Version:      1.0
-- Copyright:    (c)2011, De Haagse Hogeschool
--
-- This ia an example of a VHDL testbench. In this
-- testbench, signal paterns are generated, which are
-- presented to the component that is simulated
--

library ieee;                                               
use ieee.std_logic_1164.all;                                

-- Top level entity for simulation has no
-- port signals
entity tb_xor4nands is
end tb_xor4nands;

architecture testbench of tb_xor4nands is

-- Internal signal for displaying in de simulator
signal X : std_logic;
signal Y : std_logic;
signal S : std_logic;

-- The VHDL component to be simulated
component xor4nands
	port (
		X : in std_logic;
		Y : in std_logic;
		S : out std_logic
	);
end component;

-- Begin with instantiating the component
begin
	dut : xor4nands
	port map (
		-- mapping is as follows:
		-- signal_of_component => signal_in_testbench
		X => X,
		Y => Y,
		S => S
	);

	-- Testbench process: generate a waveform on all
	-- input signals. This is behavioral VHDL and
	-- cannot be synthesized.
	gen : process is                                              
	begin
		wait for 100 ns;
		X <= '0';
		Y <= '0';
		wait for 100 ns;
		X <= '0';
		Y <= '1';
		wait for 100 ns;
		X <= '1';
		Y <= '0';
		wait for 100 ns;
		X <= '1';
		Y <= '1';
		wait for 100 ns;
		X <= '0';
		Y <= '0';
		wait for 100 ns;
		wait;
	end process gen;
	
end testbench;
